from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, String

Wossoperation_V0_1_0 = CommandToolBuilder(tool="wossoperation", base_command=["wossoperation"], inputs=[ToolInput(tag="in_explode", input_type=Boolean(optional=True), prefix="-explode", doc=InputDocumentation(doc="boolean    [N] The groups that EMBOSS applications\nbelong to have two forms, exploded and not\nexploded. The exploded group names are more\nnumerous and often vaguely phrased than the\nnon-exploded ones. The exploded names are\nformed from definitions of the group names\nthat start like NAME1:NAME2 and which are\nthen expanded into many combinations of the\nnames as: 'NAME1', 'NAME2', 'NAME1 NAME2',\nNAME2 NAME1'. The non-expanded names are\nsimply like: 'NAME1 NAME2'.")), ToolInput(tag="in_show_keywords", input_type=Boolean(optional=True), prefix="-showkeywords", doc=InputDocumentation(doc="boolean    [N] Show keywords with program documentation")), ToolInput(tag="in_outfile", input_type=File(optional=True), prefix="-outfile", doc=InputDocumentation(doc="outfile    [stdout] Tool metadata output file")), ToolInput(tag="in_html", input_type=File(optional=True), prefix="-html", doc=InputDocumentation(doc="toggle     [N] If you are sending the output to a file,\nthis will format it for displaying as a\ntable in a WWW document.")), ToolInput(tag="in_groups", input_type=Boolean(optional=True), prefix="-groups", doc=InputDocumentation(doc="boolean    [N] If you use this option, then only the\ngroup names will be output to the file")), ToolInput(tag="in_alphabetic", input_type=Boolean(optional=True), prefix="-alphabetic", doc=InputDocumentation(doc="boolean    [N] If you use this option, then you will\nget a single list of the program names and\ndescriptions instead of the programs being\nlisted in their functional groups.")), ToolInput(tag="in_sensitive", input_type=Boolean(optional=True), prefix="-sensitive", doc=InputDocumentation(doc="boolean    [N] By default, the query keywords are\nmatched against the EDAM term names (and\nsynonyms) only. This option also matches the\nkeywords against the EDAM term definitions\nand will therefore (typically) report more\nmatches.")), ToolInput(tag="in_obsolete", input_type=Boolean(optional=True), prefix="-obsolete", doc=InputDocumentation(doc="boolean    [N] The default behaviour is to not use or\nreturn obsolete terms. This option if set\nwill include all terms.")), ToolInput(tag="in_emboss", input_type=String(optional=True), prefix="-emboss", doc=InputDocumentation(doc="is true). EMBASSY programs")), ToolInput(tag="in_show_embassy", input_type=Boolean(optional=True), prefix="-showembassy", doc=InputDocumentation(doc="string     If you use this option then this EMBASSY\npackage program documentation will be\nsearched. EMBASSY programs are not strictly\npart of EMBOSS, but use the same code\nlibraries and share the same look and feel,\nbut are generally developed by people who\nwish the programs to be outside of the GNU\nPublic Licence scheme (Any string)")), ToolInput(tag="in_colon", input_type=Boolean(optional=True), prefix="-colon", doc=InputDocumentation(doc="boolean    [N] The groups that EMBOSS applications\nbelong to up to two levels, for example the\nprimary group 'ALIGNMENT' has several\nsub-groups, or second-level groups, e.g.:\nCONSENSUS, DIFFERENCES, DOT PLOTS, GLOBAL,\nLOCAL, MULTIPLE. To aid programs that parse\nthe output of wossname that require the\nnames of these subgroups, a colon ':' will\nbe placed between the first and second level\nof the group name if this option is true.\nNote: This does not apply if the group names\nhave been exploded with the 'explode'\noption.")), ToolInput(tag="in_gui", input_type=Boolean(optional=True), prefix="-gui", doc=InputDocumentation(doc="boolean    [N] This option is intended to help those\nwho are designing Graphical User Interfaces\nto the EMBOSS applications. Some EMBOSS\nprograms are inappropriate for running in a\nGUI, these include other menu programs and\ninteractive editors. This option allows you\nto only report those programs that can be\nrun from a GUI"))], outputs=[ToolOutput(tag="out_outfile", output_type=File(optional=True), selector=InputSelector(input_to_select="in_outfile", type_hint=File()), doc=OutputDocumentation(doc="outfile    [stdout] Tool metadata output file")), ToolOutput(tag="out_html", output_type=File(optional=True), selector=InputSelector(input_to_select="in_html", type_hint=File()), doc=OutputDocumentation(doc="toggle     [N] If you are sending the output to a file,\nthis will format it for displaying as a\ntable in a WWW document."))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Wossoperation_V0_1_0().translate("wdl", allow_empty_container=True)

